#include <iostream>

using namespace std;

int main()
{
    int n,q,i,j,l,r;
    cin >> n >> q ;
    int a[n];
    int h[q];
    for(i=0;i<n;i++)
        cin >> a[i];
    for(i=0;i<q;i++)
    {
        cin >> l >> r;
        h[i] = a[l-1];
        for(j=l;j<r;j++)
            h[i] = h[i] & a[j];
    }
    for(i=0;i<q;i++)
        cout << h[i] << endl;
    return 0;
}